#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser warningsToBrowser); 
###############################################################################
# webflare.pl                                                                 #
###############################################################################
# Web page editor for Flying Kirby Pub website.                               #
# Date started: October 23rd, 2005                                            #
# Version: DEV [2005-10-23]                                                   #
# Released by AK108 for use by the Flying Kirby Pub (http://fkp.jkcsi.com)    #
###############################################################################

$YaBBversion = 'YaBB 2.1';

$sidebarurl = "http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}";

### This is grafted on top of YaBB 2.
### YaBB 2 Init stuff
{
	push(@INC, './Modules');
	push(@INC, './Modules/Upload');
	push(@INC, './Modules/Digest');

	$script_root = $ENV{'SCRIPT_FILENAME'};
	$script_root =~ s/\/Sidebar\.pl//ig;

	if (-e "Paths.pl") { require "Paths.pl"; }
	elsif (-e "$script_root/Paths.pl") { require "$script_root/Paths.pl"; }

	require "$vardir/Settings.pl";
	require "$vardir/advsettings.txt";
	require "$vardir/secsettings.txt";
	require "$vardir/membergroups.txt";
	require "$sourcedir/Subs.pl";
	require "$sourcedir/DateTime.pl";
	require "$sourcedir/Load.pl";

	# Fool YaBB if needed before loading Security.
#	my($oldaction) = $action;
	$action = "sidebar";
	require "$sourcedir/Security.pl";
#	$action = $oldaction;
	undef $action;

	&LoadCookie;          # Load the user's cookie (or set to guest)
	&LoadUserSettings;    # Load user settings
	&WhatTemplate;        # Figure out which template to be using.
	&WhatLanguage;        # Figure out which language file we should be using! :D

	&banning;     # Check for banned people
	&WriteLog;    # Write to the log
	&LoadIMs;     # Load IM's
}

#$debug = 0;

### Load the master files
require "$boardsdir/forum.master";

### AK108 Board Index User Cache
if(-e "$vardir/boardindexusers.cache") {
	# Trap any syntax errors that might be in the file
	eval 'require "$vardir/boardindexusers.cache"';

	# You can trap errors here by uncommenting the following if statement
	# And putting something inside the block
	#if($@) {} # the code in the if block is executed if there is an error

	# It is probably a good idea to remove the file if it's bad.
	if($@) {unlink "$vardir/boardindexusers.cache";}
}

LoadLanguage('BoardIndex');

$yymain .= qq~
<div class="seperator">
~;

# first get all the boards based on the categories found in forum.master
foreach $catid (@categoryorder) {
	if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
	$boardlist = $cat{$catid};
	(@bdlist) = split(/\,/, $boardlist);
	my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{$catid});

	# Category Permissions Check
	my $access = &CatAccess($catperms);
	if (!$access) { next; }
	$cat_boardcnt{$catid} = 0;

	# next determine all the boards a user has access to
	foreach $curboard (@bdlist) {

		# now fill all the neccesary hashes to show all board index stuff
		chomp $curboard;
		if (!exists $board{$curboard}) {
			&gostRemove($catid, $curboard);
			next;
		}

		# hide the actual global announcement board for all normal users but admins and gmods
		if ($annboard eq $curboard && !$iamadmin && !$iamgmod) { next; }

		my ($boardname, $boardperms, $boardview) = split(/\|/, $board{$curboard});
		my $access = &AccessCheck($curboard, '', $boardperms);
		if (!$iamadmin && $access ne 'granted' && $boardview != 1) { next; }
		push(@goodboards, "$catid|$curboard");
		push(@loadboards, $curboard);
		$cat_boardcnt{$catid}++;
	}
}

&BoardInfo(@loadboards);
&getlog($curboard);

foreach $catid (@categoryorder) {
	if ($INFO{'catselect'} ne $catid && $INFO{'catselect'}) { next; }
	$boardlist = $cat{$catid};
	(@bdlist) = split(/\,/, $boardlist);
	my ($catname, $catperms, $catallowcol) = split(/\|/, $catinfo{$catid});

	# Category Permissions Check
	my $access = &CatAccess($catperms);
	if (!$access) { next; }
	$cat_boardcnt{$catid} = 0;

	my $catnew = 0;

	my $noborder = '';
	if($categoryorder[0] eq $catid) {$noborder = ' style="border-top: none;"';}
	$yymain .= qq~<div class="catbg"$noborder><a href="$scripturl?catselect=$catid" title="View $catname">--new image placeholder for $catid-- $catname</a></div>~;

	# next determine all the boards a user has access to. Again.
	foreach $curboard (@bdlist) {
		my ($boardname, $boardperms, $boardview) = split(/\|/, $board{$curboard});
		my $access = &AccessCheck($curboard, '', $boardperms);
		if (!$iamadmin && $access ne 'granted' && $boardview != 1) { next; }
		if (!$iamadmin && (${$uid.$curboard}{'ann'} || ${$uid.$curboard}{'rbin'})) {next;}

		# now fill all the neccesary hashes to show all board index stuff
		chomp $curboard;
		if (!exists $board{$curboard}) {
			next;
		}

		my $dlp = $yyuserlog{$curboard} ? $yyuserlog{$curboard} : 0;
		if($max_log_days_old && ${$uid.$curboard}{'lastposttime'} ne $boardindex_txt{'470'}&& !$iamguest && $dlp < $lastpostrealtime{$curboard} && ($dlp > $max_log_days_old * 86400 || $dlp == 0)) {
			my (undef, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
			if (&AccessCheck($curboard, '', $boardperms) eq 'granted') {
				$new = qq~<a href="$scripturl?num=${$uid.$curboard}{'lastpostid'}/${$uid.$curboard}{'lastreply'}#${$uid.$curboard}{'lastreply'}"><img src="$imagesdir/new1.gif" alt="$boardindex_txt{'333'}" border="0" /></a> ~;
				$catnew = 1;
			} else {
				$new = qq~~;
			}
		} else {
			$new = qq~~;
		}
		#if (${$uid.$curboard}{'ann'} == 1)  { $new = qq~<img src="$imagesdir/ann.gif" alt="" border="0" />~; }
		#if (${$uid.$curboard}{'rbin'} == 1) { $new = qq~<img src="$imagesdir/recycle.gif" alt="" border="0" />~; }

		$yymain .= qq~<div class="windowbg2">$new<a name="$curboard" href="$scripturl?board=$curboard">$boardname</a></div>
~;
	}
	if($catnew) {$yymain =~ s~--new image placeholder for $catid--~<img src="$imagesdir/new1.gif" alt="$boardindex_txt{'333'}" border="0" />~;}
	else {$yymain =~ s~--new image placeholder for $catid--~~;}
}

$yymain .= qq~
</div>~;

### IMs

if (!$iamguest) {
	$ims = @immessages;

	$ims = qq~$boardindex_txt{'795'} <a href="$scripturl?action=im"><b>$ims</b></a> $boardindex_txt{'796'}~;
	if ($#immessages > 0) {
		if ($imnewcount == 1) {
			$ims .= qq~ $boardindex_imtxt{'24'} <a href="$scripturl?action=im"><b>$imnewcount</b></a> $boardindex_imtxt{'25'}.~;
		} else {
			$ims .= qq~ $boardindex_imtxt{'24'} <a href="$scripturl?action=im"><b>$imnewcount</b></a> $boardindex_imtxt{'26'}.~;
		}
	} else {
		$ims .= qq~.~;
	}
}

### Users online
my $checkadded = 0;
$users     = qq~<span class="small">~;
$guestlist = qq~<span class="small">~;
$guests    = 0;
$numusers  = 0;
fopen(VARLOG, "$vardir/log.txt");
@entries = <VARLOG>;
fclose(VARLOG);

foreach $curentry (@entries) {
	chomp $curentry;
	($name, $value, $last_ip) = split(/\|/, $curentry);
	if (!$last_ip) { $last_ip = qq~</i></span><span class="error">$boardindex_txt{'no_ip'}</span><span class="small"><i>~; }
	if ($name) {
		if (-e ("$memberdir/$name.vars")) {
			unless (${$uid.$name}{'realname'}) { &LoadUser($name); }
			&LoadMiniUser($name);
			$numusers++;
			$users .= qq~$link{$name}~;
#			if (($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
#				$users .= qq~<i> ($last_ip)</i>~;
#			}
			$users .= qq~, ~;
		} else {
			$guests++;
			if (($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) {
				$guestlist .= qq~<i>$last_ip</i>, ~;
			}
		}
	}
}
$users =~ s~, \Z~~;
$users .= qq~</span>~;
if ($numusers) { $users .= qq~<br />~; }
$guestlist =~ s~, \Z~~;
$guestlist .= qq~</span>~;

### Info center

$yymain .= qq~
<br />
<div class="seperator">
	<div class="titlebg" align="center">
		Info Center
	</div>
~;
unless($iamguest) {
	$yymain .= qq~
	<div align="left" class="windowbg2">
		<span class="small">$ims</span>
	</div>
	<div align="left" class="catbg">
		Users online
	</div>
~;
}
$yymain .= qq~
	<div class="windowbg2">
		<span class="small">$boardindex_txt{'142'}: <b>$numusers</b></span><br />
		$users
		<span class="small">$boardindex_txt{'141'}: <b>$guests</b></span><br />
		$guestlist
	</div>
</div>~;

if ($imnewcount > 0) {
	if ($imnewcount > 1) { $en = "s"; $en2 = "$boardindex_imtxt{'47'}"; }
	else { $en = ""; $en2 = "$boardindex_imtxt{'48'}"; }

	chomp(${$uid.$username}{'im_imspop'});
	chomp(${$uid.$username}{'im_popup'});

	if (${$uid.$username}{'im_popup'} eq "on") {
		$yymain .= qq~
<script language="JavaScript" type="text/javascript">
function rimpu() { window.open("$scripturl?action=im") }
function cancel () { }
</script>~;
		$yymain .= qq~
<script language="JavaScript" type="text/javascript">
<!-- BEGIN
	if (confirm("$boardindex_imtxt{'14'} $imnewcount$boardindex_imtxt{'15'}?")) { rimpu(); } else cancel()
// END -->
</script>
	~;
	}
}

$yytitle = 'FKP Sidebar';

{
	my $gzaccept = $ENV{'HTTP_ACCEPT_ENCODING'} =~ /\bgzip\b/ || $gzforce;

	#print header
	if ($gzcomp && $gzaccept) {
		if ($yySetCookies1 || $yyetCookies2 || $yySetCookies3) {
			$cookiewritten = "Cookie Set";
			print header(-status            => '200 OK',
				'Content-Encoding' => 'gzip',
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
				-charset => $yycharset);
		} else {
			print header(-status            => '200 OK',
				'Content-Encoding' => 'gzip',
				-charset           => $yycharset);
		}
	} else {
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3) {
			$cookiewritten = "Cookie Set";
			print header(-status => '200 OK',
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
				-charset => $yycharset);
		} else {
			print header(-status  => '200 OK',
				-charset => $yycharset);
		}
	}

#	$yyposition = $yytitle;
#	$yytitle    = "$mbname - $yytitle";

	$yyimages        = $imagesdir;
	$yydefaultimages = $defaultimagesdir;
	$yystyle         = qq~<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />~;
	$yystyle      =~ s~$usestyle\/~~g;
	$yystylesheet =    $yystyle;

	$output = qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$yytitle</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<meta http-equiv="Refresh" content="300" />
$yystyle
<style type="text/css">
.windowbg2, .windowbg, .catbg {border-top: 1px black solid; padding: 4px;}
.titlebg {padding: 4px;}
</style>
<script language="JavaScript1.2" type="text/javascript">
<!--
//force no cache
if ((navigator.appVersion.substring(0,1) == "5" && navigator.userAgent.indexOf('Gecko') != -1) || navigator.userAgent.search(/Opera/) != -1) {
document.write('<meta http-equiv="pragma" CONTENT="no-cache" />');
}
//scroll fix for IE
window.onload = function ()
		{
			if(document.all) {
				var codeFix = document.all.tags("div");
				for (var codeI = 0; codeI < codeFix.length; codeI++)
				{
					if (codeFix[codeI].className == "scroll" && (codeFix[codeI].scrollWidth > codeFix[codeI].clientWidth || codeFix[codeI].clientWidth == 0))
					codeFix[codeI].style.height = (codeFix[codeI].clientHeight + 34) + "px";
				}
			}
		}

// -->
</script>
</head>
<body>
<div id="container">
<div class="seperator">
<div class="windowbg" style="border-top: none;" align="center">
Welcome $username
</div>
<div class="windowbg2" align="center">
<a href="$sidebarurl" target="_self">Refresh</a> | <a href="$scripturl">Forum Index</a>
</div>
</div>
<br />
$yymain
<div class="copyright" style="text-align: center;">
<br />
$yycopyright<br /><br />
</div>
</div>
</body>
</html>
~;
	$yyboardname = $mbname;
	$yyurl      = $scripturl;

	if ($output =~ m~$yycopyright~) { $yycopyin = 1; }
#	$addsession = qq~<input type="hidden" name="formsession" value="$formsession" /></form>~;
#	$output =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
#	$curline =~ s~<includefile="(\S+)">~${\(IncludeFile($1))}~g;
#	$curline =~ s~(a href\=\S+?action\=viewprofile\;username\=.+?)(\>)~$1 rel=\"nofollow\"$2~isg;
	$curline =~ s~img src\=\"$imagesdir\/(.+?)\"~&ImgLoc($1)~eisg;
#	$curline =~ s~(img src\=\"$imagesdir\/.+?)title\=\"(.*?)\"(.*? \/\>)~$1$3~ig;
#	$curline =~ s~alt\=\"(.*?)\"~alt\=\"$1\" title\=\"$1\"~ig;
#	$curline =~ s~</form>~$addsession~g;

	if ($yycopyin == 0) {
		$output = q~<center><h1><b>Sorry, the copyright tag <yabb copyright> must be in the template.<br />Please notify this forum\'s administrator that this site is using an ILLEGAL copy of YaBB!</b></h1></center>~;
	}

	### Use the InlineImages method if it works for sure in the browser of the user
	if(index($ENV{'HTTP_USER_AGENT'}, 'Gecko') != -1) {
		$output =~ s~\<img src=\"$imagesdir\/new1\.gif\"~\<img src=\"data:image\/gif;base64,R0lGODlhFgAJAKECAAAAALw0Ov///////yH5BAEAAAMALAAAAAAWAAkAAAIu3ICpi2YQopw0gheFljsIbh3Z+HnmGFzQ+Wlbe6ooDNIym3V0ilW+dHEwhgpHAQA7\"~g;
	}
	###

	# do output
	if ($gzcomp && $gzaccept) {
		if ($gzcomp == 1) {
			$| = 1;
			open(GZIP, "| gzip -f");
			print GZIP $output;
			close(GZIP);
		} else {
			require Compress::Zlib;
			binmode STDOUT;
			print Compress::Zlib::memGzip($output);
		}
	} else {
		print $output;
	}
}
